# Label Noise Injection Tools
This page contains links to the tools developed at the [Remote Sensing Image Analysis group](https://www.rsim.tu-berlin.de/menue/remote_sensing_image_analysis_group/) to inject synthetic multi-label noise into image datasets. The obtained noisy labeled datasets can be used in the experiments to evaluate the robustness of the machine learning models against label noise. Both tools given below work on [Numpy](https://numpy.org/) arrays and are independent of specific deep learning libraries.

## 1) Multi Label Noise Injection Tool
[Multi-Label Noise Injection tool](https://git.tu-berlin.de/rsim/multi_label_noise) contains a set of helper functions in order to create noisy multi-label matrices. The tool allows to inject additive (extra classes) and subtractive (missing classes) noise separately.

![](images/multi-label_noise_injection_figure.png)

## 2) Noisifier Tool 
[Noisifier tool](https://git.tu-berlin.de/rsim/noisifier) allows to add synthetic multi-label noise to the multi-labeled image datasets. It is also applicable to the datasets containing single-labeled images.

![](images/noisifier_figure.jpg)
